Index: /pykota/branches/1.26_fixes/pykota/storages/sql.py
===================================================================
--- /pykota/branches/1.26_fixes/pykota/storages/sql.py (revision 3393)
+++ /pykota/branches/1.26_fixes/pykota/storages/sql.py (revision 3522)
@@ -721,31 +732,31 @@
                                self.doQuote(self.userCharsetToDatabase(bcode.Description)), \
                                self.doQuote(bcode.ident)))
-       
+
     def consumeBillingCode(self, bcode, pagecounter, balance) :
         """Consumes from a billing code."""
         self.doModify("UPDATE billingcodes SET balance=balance + %s, pagecounter=pagecounter + %s WHERE id=%s" % (self.doQuote(balance), self.doQuote(pagecounter), self.doQuote(bcode.ident)))
-       
-    def refundJob(self, jobident) :   
+
+    def refundJob(self, jobident) :
         """Marks a job as refunded in the history."""
         self.doModify("UPDATE jobhistory SET action='REFUND' WHERE id=%s;" % self.doQuote(jobident))
-        
-    def decreaseUserAccountBalance(self, user, amount) :    
+
+    def decreaseUserAccountBalance(self, user, amount) :
         """Decreases user's account balance from an amount."""
         self.doModify("UPDATE users SET balance=balance - %s WHERE id=%s" % (self.doQuote(amount), self.doQuote(user.ident)))
-       
+
     def writeNewPayment(self, user, amount, comment="") :
         """Adds a new payment to the payments history."""
         if user.ident is not None :
             self.doModify("INSERT INTO payments (userid, amount, description) VALUES (%s, %s, %s)" % (self.doQuote(user.ident), self.doQuote(amount), self.doQuote(self.userCharsetToDatabase(comment))))
-        else :    
+        else :
             self.doModify("INSERT INTO payments (userid, amount, description) VALUES ((SELECT id FROM users WHERE username=%s), %s, %s)" % (self.doQuote(self.userCharsetToDatabase(user.Name)), self.doQuote(amount), self.doQuote(self.userCharsetToDatabase(comment))))
-        
-    def writeLastJobSize(self, lastjob, jobsize, jobprice) :        
+
+    def writeLastJobSize(self, lastjob, jobsize, jobprice) :
         """Sets the last job's size permanently."""
         self.doModify("UPDATE jobhistory SET jobsize=%s, jobprice=%s WHERE id=%s" % (self.doQuote(jobsize), self.doQuote(jobprice), self.doQuote(lastjob.ident)))
-        
+
     def writeJobNew(self, printer, user, jobid, pagecounter, action, jobsize=None, jobprice=None, filename=None, title=None, copies=None, options=None, clienthost=None, jobsizebytes=None, jobmd5sum=None, jobpages=None, jobbilling=None, precomputedsize=None, precomputedprice=None) :
         """Adds a job in a printer's history."""
-        if self.privacy :    
+        if self.privacy :
             # For legal reasons, we want to hide the title, filename and options
             title = filename = options = "hidden"
@@ -757,10 +768,10 @@
             if jobsize is not None :
                 self.doModify("INSERT INTO jobhistory (userid, printerid, jobid, pagecounter, action, jobsize, jobprice, filename, title, copies, options, hostname, jobsizebytes, md5sum, pages, billingcode, precomputedjobsize, precomputedjobprice) VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)" % (self.doQuote(user.ident), self.doQuote(printer.ident), self.doQuote(jobid), self.doQuote(pagecounter), self.doQuote(action), self.doQuote(jobsize), self.doQuote(jobprice), self.doQuote(filename), self.doQuote(title), self.doQuote(copies), self.doQuote(options), self.doQuote(clienthost), self.doQuote(jobsizebytes), self.doQuote(jobmd5sum), self.doQuote(jobpages), self.doQuote(jobbilling), self.doQuote(precomputedsize), self.doQuote(precomputedprice)))
-            else :    
+            else :
                 self.doModify("INSERT INTO jobhistory (userid, printerid, jobid, pagecounter, action, filename, title, copies, options, hostname, jobsizebytes, md5sum, pages, billingcode, precomputedjobsize, precomputedjobprice) VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)" % (self.doQuote(user.ident), self.doQuote(printer.ident), self.doQuote(jobid), self.doQuote(pagecounter), self.doQuote(action), self.doQuote(filename), self.doQuote(title), self.doQuote(copies), self.doQuote(options), self.doQuote(clienthost), self.doQuote(jobsizebytes), self.doQuote(jobmd5sum), self.doQuote(jobpages), self.doQuote(jobbilling), self.doQuote(precomputedsize), self.doQuote(precomputedprice)))
-        else :        
+        else :
             # here we explicitly want to reset jobsize to NULL if needed
             self.doModify("UPDATE jobhistory SET userid=%s, jobid=%s, pagecounter=%s, action=%s, jobsize=%s, jobprice=%s, filename=%s, title=%s, copies=%s, options=%s, hostname=%s, jobsizebytes=%s, md5sum=%s, pages=%s, billingcode=%s, precomputedjobsize=%s, precomputedjobprice=%s, jobdate=now() WHERE id=%s" % (self.doQuote(user.ident), self.doQuote(jobid), self.doQuote(pagecounter), self.doQuote(action), self.doQuote(jobsize), self.doQuote(jobprice), self.doQuote(filename), self.doQuote(title), self.doQuote(copies), self.doQuote(options), self.doQuote(clienthost), self.doQuote(jobsizebytes), self.doQuote(jobmd5sum), self.doQuote(jobpages), self.doQuote(jobbilling), self.doQuote(precomputedsize), self.doQuote(precomputedprice), self.doQuote(printer.LastJob.ident)))
-            
+
     def saveUserPQuota(self, userpquota) :
         """Saves an user print quota entry."""
@@ -774,13 +785,13 @@
                                  self.doQuote(userpquota.MaxJobSize), \
                                  self.doQuote(userpquota.ident)))
-        
+
     def writeUserPQuotaWarnCount(self, userpquota, warncount) :
         """Sets the warn counter value for a user quota."""
         self.doModify("UPDATE userpquota SET warncount=%s WHERE id=%s" % (self.doQuote(warncount), self.doQuote(userpquota.ident)))
-        
+
     def increaseUserPQuotaWarnCount(self, userpquota) :
         """Increases the warn counter value for a user quota."""
         self.doModify("UPDATE userpquota SET warncount=warncount+1 WHERE id=%s" % self.doQuote(userpquota.ident))
-        
+
     def saveGroupPQuota(self, grouppquota) :
         """Saves a group print quota entry."""
@@ -798,11 +809,11 @@
             for record in result :
                 children.append(record.get("printerid")) # TODO : put this into the database integrity rules
-        if printer.ident not in children :        
+        if printer.ident not in children :
             self.doModify("INSERT INTO printergroupsmembers (groupid, printerid) VALUES (%s, %s)" % (self.doQuote(pgroup.ident), self.doQuote(printer.ident)))
-        
+
     def removePrinterFromGroup(self, pgroup, printer) :
         """Removes a printer from a printer group."""
         self.doModify("DELETE FROM printergroupsmembers WHERE groupid=%s AND printerid=%s" % (self.doQuote(pgroup.ident), self.doQuote(printer.ident)))
-        
+
     def retrieveHistory(self, user=None, printer=None, hostname=None, billingcode=None, jobid=None, limit=100, start=None, end=None) :
         """Retrieves all print jobs for user on printer (or all) between start and end date, limited to first 100 results."""
@@ -813,21 +824,21 @@
         if printer is not None : # printer.ident is None anyway if printer doesn't exist
             where.append("printerid=%s" % self.doQuote(printer.ident))
-        if hostname is not None :    
+        if hostname is not None :
             where.append("hostname=%s" % self.doQuote(hostname))
-        if billingcode is not None :    
+        if billingcode is not None :
             where.append("billingcode=%s" % self.doQuote(self.userCharsetToDatabase(billingcode)))
-        if jobid is not None :    
+        if jobid is not None :
             where.append("jobid=%s" % self.doQuote(jobid)) # TODO : jobid is text, so self.userCharsetToDatabase(jobid) but do all of them as well.
-        if start is not None :    
+        if start is not None :
             where.append("jobdate>=%s" % self.doQuote(start))
-        if end is not None :    
+        if end is not None :
             where.append("jobdate<=%s" % self.doQuote(end))
-        if where :    
+        if where :
             query += " AND %s" % " AND ".join(where)
         query += " ORDER BY jobhistory.id DESC"
         if limit :
             query += " LIMIT %s" % self.doQuote(int(limit))
-        jobs = []    
-        result = self.doSearch(query)    
+        jobs = []
+        result = self.doSearch(query)
         if result :
             for fields in result :
@@ -835,11 +846,11 @@
                 jobs.append(job)
         return jobs
-        
-    def deleteUser(self, user) :    
+
+    def deleteUser(self, user) :
         """Completely deletes an user from the database."""
         # TODO : What should we do if we delete the last person who used a given printer ?
         # TODO : we can't reassign the last job to the previous one, because next user would be
         # TODO : incorrectly charged (overcharged).
-        for q in [ 
+        for q in [
                     "DELETE FROM payments WHERE userid=%s" % self.doQuote(user.ident),
                     "DELETE FROM groupsmembers WHERE userid=%s" % self.doQuote(user.ident),
@@ -849,6 +860,6 @@
                   ] :
             self.doModify(q)
-            
-    def multipleQueriesInTransaction(self, queries) :        
+
+    def multipleQueriesInTransaction(self, queries) :
         """Does many modifications in a single transaction."""
         self.beginTransaction()
@@ -856,22 +867,22 @@
             for q in queries :
                 self.doModify(q)
-        except :    
+        except :
             self.rollbackTransaction()
             raise
-        else :    
+        else :
             self.commitTransaction()
-            
-    def deleteManyBillingCodes(self, billingcodes) :        
+
+    def deleteManyBillingCodes(self, billingcodes) :
         """Deletes many billing codes."""
         codeids = ", ".join(["%s" % self.doQuote(b.ident) for b in billingcodes])
         if codeids :
-            self.multipleQueriesInTransaction([ 
+            self.multipleQueriesInTransaction([
                     "DELETE FROM billingcodes WHERE id IN (%s)" % codeids,])
-            
-    def deleteManyUsers(self, users) :        
+
+    def deleteManyUsers(self, users) :
         """Deletes many users."""
         userids = ", ".join(["%s" % self.doQuote(u.ident) for u in users])
         if userids :
-            self.multipleQueriesInTransaction([ 
+            self.multipleQueriesInTransaction([
                     "DELETE FROM payments WHERE userid IN (%s)" % userids,
                     "DELETE FROM groupsmembers WHERE userid IN (%s)" % userids,
@@ -879,19 +890,19 @@
                     "DELETE FROM userpquota WHERE userid IN (%s)" % userids,
                     "DELETE FROM users WHERE id IN (%s)" % userids,])
-                    
-    def deleteManyGroups(self, groups) :        
+
+    def deleteManyGroups(self, groups) :
         """Deletes many groups."""
         groupids = ", ".join(["%s" % self.doQuote(g.ident) for g in groups])
         if groupids :
-            self.multipleQueriesInTransaction([ 
+            self.multipleQueriesInTransaction([
                     "DELETE FROM groupsmembers WHERE groupid IN (%s)" % groupids,
                     "DELETE FROM grouppquota WHERE groupid IN (%s)" % groupids,
                     "DELETE FROM groups WHERE id IN (%s)" % groupids,])
-        
+
     def deleteManyPrinters(self, printers) :
         """Deletes many printers."""
         printerids = ", ".join(["%s" % self.doQuote(p.ident) for p in printers])
         if printerids :
-            self.multipleQueriesInTransaction([ 
+            self.multipleQueriesInTransaction([
                     "DELETE FROM printergroupsmembers WHERE groupid IN (%s) OR printerid IN (%s)" % (printerids, printerids),
                     "DELETE FROM jobhistory WHERE printerid IN (%s)" % printerids,
@@ -899,16 +910,16 @@
                     "DELETE FROM userpquota WHERE printerid IN (%s)" % printerids,
                     "DELETE FROM printers WHERE id IN (%s)" % printerids,])
-        
-    def deleteManyUserPQuotas(self, printers, users) :        
+
+    def deleteManyUserPQuotas(self, printers, users) :
         """Deletes many user print quota entries."""
         printerids = ", ".join(["%s" % self.doQuote(p.ident) for p in printers])
         userids = ", ".join(["%s" % self.doQuote(u.ident) for u in users])
         if userids and printerids :
-            self.multipleQueriesInTransaction([ 
+            self.multipleQueriesInTransaction([
                     "DELETE FROM jobhistory WHERE userid IN (%s) AND printerid IN (%s)" \
                                  % (userids, printerids),
                     "DELETE FROM userpquota WHERE userid IN (%s) AND printerid IN (%s)" \
                                  % (userids, printerids),])
-            
+
     def deleteManyGroupPQuotas(self, printers, groups) :
         """Deletes many group print quota entries."""
@@ -916,11 +927,11 @@
         groupids = ", ".join(["%s" % self.doQuote(g.ident) for g in groups])
         if groupids and printerids :
-            self.multipleQueriesInTransaction([ 
+            self.multipleQueriesInTransaction([
                     "DELETE FROM grouppquota WHERE groupid IN (%s) AND printerid IN (%s)" \
                                  % (groupids, printerids),])
-        
-    def deleteUserPQuota(self, upquota) :    
+
+    def deleteUserPQuota(self, upquota) :
         """Completely deletes an user print quota entry from the database."""
-        for q in [ 
+        for q in [
                     "DELETE FROM jobhistory WHERE userid=%s AND printerid=%s" \
                                  % (self.doQuote(upquota.User.ident), self.doQuote(upquota.Printer.ident)),
@@ -928,13 +939,13 @@
                   ] :
             self.doModify(q)
-        
-    def deleteGroupPQuota(self, gpquota) :    
+
+    def deleteGroupPQuota(self, gpquota) :
         """Completely deletes a group print quota entry from the database."""
-        for q in [ 
+        for q in [
                     "DELETE FROM grouppquota WHERE id=%s" % self.doQuote(gpquota.ident),
                   ] :
             self.doModify(q)
-        
-    def deleteGroup(self, group) :    
+
+    def deleteGroup(self, group) :
         """Completely deletes a group from the database."""
         for q in [
@@ -942,10 +953,10 @@
                    "DELETE FROM grouppquota WHERE groupid=%s" % self.doQuote(group.ident),
                    "DELETE FROM groups WHERE id=%s" % self.doQuote(group.ident),
-                 ] :  
+                 ] :
             self.doModify(q)
-            
-    def deletePrinter(self, printer) :    
+
+    def deletePrinter(self, printer) :
         """Completely deletes a printer from the database."""
-        for q in [ 
+        for q in [
                     "DELETE FROM printergroupsmembers WHERE groupid=%s OR printerid=%s" % (self.doQuote(printer.ident), self.doQuote(printer.ident)),
                     "DELETE FROM jobhistory WHERE printerid=%s" % self.doQuote(printer.ident),
@@ -955,10 +966,10 @@
                   ] :
             self.doModify(q)
-            
-    def deleteBillingCode(self, code) :    
+
+    def deleteBillingCode(self, code) :
         """Completely deletes a billing code from the database."""
         for q in [
                    "DELETE FROM billingcodes WHERE id=%s" % self.doQuote(code.ident),
-                 ] :  
+                 ] :
             self.doModify(q)
-        
+
